#function to resize the characters:
init python:
    class ProportionalScale(im.ImageBase): # A mix between im.Scale and im.FactorScale for character images
        def __init__(self, imgname, maxwidth, maxheight, bilinear=True, **properties):
            img = im.image(imgname)
            super(ProportionalScale, self).__init__(img, maxwidth, maxheight, bilinear, **properties)
            self.imgname = imgname
            self.image = img
            self.maxwidth = int(maxwidth)
            self.maxheight = int(maxheight)
            self.bilinear = bilinear

        def load(self):
            child = im.cache.get(self.image)
            currentwidth, currentheight = child.get_size()
            xscale = 1.0
            yscale = 1.0
            if (currentwidth > self.maxwidth):
                xscale = float(self.maxwidth) / float(currentwidth)
            if (currentheight > self.maxheight):
                yscale = float(self.maxheight) / float(currentheight)
            if (xscale < yscale):
                minscale = xscale
            else:
                minscale = yscale
            newwidth = currentwidth * minscale
            newheight = currentheight * minscale
            #renpy.log("Loading image %s from %f x %f to %f x %f" % (self.imgname, currentwidth , currentheight , newwidth, newheight)) # Debug code to see when the loading really happens
            if self.bilinear:
                try:
                    renpy.display.render.blit_lock.acquire()
                    rv = renpy.display.scale.smoothscale(child, (newwidth, newheight))
                finally:
                    renpy.display.render.blit_lock.release()
            else:
                try:
                    renpy.display.render.blit_lock.acquire()
                    rv = renpy.display.pgrender.transform_scale(child, (newwidth, newheight))
                finally:
                    renpy.display.render.blit_lock.release()
            return rv
        def predict_files(self):
            return self.image.predict_files()

init +1 python:
    mr = MusicRoom(fadeout=1.0)
    song_list=[]
    song_list.append({"name":THEME, "title":"Where Am I", "file":"music/theme.ogg", "author":"", "link":""})
    #song_list.append({"name":ATMOSPHERE, "title":"Atmosphere", "file":"music/Atmosphere.ogg", "author":"", "link":""})
    #song_list.append({"name":CHIMES_1, "title":"Chimes 1", "file":"music/Chimes 1.ogg", "author":"", "link":""})
    song_list.append({"name":CHIMES_FULL_2, "title":"Chimes", "file":"music/Chimes Full 2.ogg", "author":"", "link":""})
    song_list.append({"name":DEATH_IS_ETERNAL, "title":"Death Is Eternal", "file":"music/Death is eternal.ogg", "author":"", "link":""})
    #song_list.append({"name":FOREST_AT_NIGHT, "title":"Forest At Night", "file":"music/forest at night.ogg", "author":"", "link":""})
    #song_list.append({"name":GRAVEYARD, "title":"Graveyard", "file":"music/graveyard.ogg", "author":"", "link":""})
    song_list.append({"name":REMOVED, "title":"Removed", "file":"music/Removed.ogg", "author":"", "link":""})
    #song_list.append({"name":THE_LIGHT_NO_PIANO, "title":"The Light No Piano", "file":"music/The Light no piano.ogg", "author":"", "link":""})
    song_list.append({"name":THE_LIGHT, "title":"The Light", "file":"music/The Light.ogg", "author":"", "link":""})
    #song_list.append({"name":TOWN, "title":"Town", "file":"music/town.ogg", "author":"", "link":""})
    #song_list.append({"name":TOWN2, "title":"Town2", "file":"music/town2.ogg", "author":"", "link":""})
    #song_list.append({"name":WIND_ATMOSPHERE_LIGHT, "title":"Wind Atmosphere Light", "file":"music/Wind Atmosphere light.ogg", "author":"", "link":""})
    #song_list.append({"name":WIND_VOICE, "title":"Wind Voice", "file":"music/Wind voice.ogg", "author":"", "link":""})
    #song_list.append({"name":WIND, "title":"Wind", "file":"music/Wind.ogg", "author":"", "link":""})
    
    for song in song_list:
        mr.add(song["name"], always_unlocked=True)

screen music_room:
    tag menu
    use extras
    add "music_room_title" xpos 152 ypos 22    
    frame background None xpos 250 ypos 150:
        has vbox spacing 15
        for song in song_list:
            textbutton song["title"] action mr.Play(song["name"])
#        null height 20
    on "replace" action mr.Play()
    on "replaced" action Play("music", config.main_menu_music)
    
    
init:
    image con1 = "concepts/con1.jpg"
    image con2 = "concepts/con2.jpg"
    image con3 = "concepts/con3.jpg"
    image con4 = "concepts/con4.jpg"
    image con5 = "concepts/con5.jpg"
    image con6 = "concepts/con6.jpg"
    image con7 = "concepts/con7.jpg"
    image con8 = "concepts/con8.jpg"
    image con9 = "concepts/con9.jpg"
    
    # image concept ghost chi = "concepts/ghost chi.jpg"
    # image concept IMG_1797 = "concepts/IMG_1797.jpg"
    # image concept IMG_1798 = "concepts/IMG_1798.jpg"
    # image concept IMG_1799 = "concepts/IMG_1799.jpg"
    # image concept moon = "concepts/moon.jpg"
#    image concept s_chi = "concepts/s-chi.jpg"
#    image concept s_rattia = "concepts/s-rattia.jpg"
#    image concept s_chi_placeholderr = "concepts/s-chi placeholderr.jpg"
#    image concept s_teto_png = "concepts/s-teto png.jpg"
#    image concept s_mo = "concepts/s-mo.jpg"
    #image concept s_khir = "concepts/s-khir.jpg"
    #image concept s_khir1 = "concepts/s-khir1.jpg"
    #image concept s_khir2 = "concepts/s-khir2.jpg"
    #image concept s_khir3 = "concepts/s-khir3.jpg"
    #image concept sprite_sketches_copy = "concepts/sprite sketches copy.jpg"
    
    
# s-chi placeholderr, 
# s-chi, 
# s-rattia, 
# s-teto, 
# s-mo 
    
#Galleries:
init python:
    #Galleries settings - start
    
    #list the CG gallery images here:
    gallery_cg_items = ["cg1", "cg2", "cg3"]
    #list the BG gallery images here:
    gallery_bg_items = ["forest", "grave", "town", ]
    
    # list one image for each sprite (neutral) here:
    gallery_ch_items = ["rattia normal", "khir normal", "chi normal", "unclean normal", "mo normal"]
    gallery_chi = ["chi angry", "chi annoyed", "chi flirty", "chi pained", "chi sad"]
    gallery_khir = [ "khir angry", "khir confident", "khir pained", "khir relieved", "khir sad", "khir surprised"]
    gallery_mo = ["mo angry", "mo regretful", "mo shocked", "mo smile", "mo thinking"]
    gallery_rattia = ["rattia angry", "rattia blank", "rattia delighted", "rattia determined", "rattia embarrassed", "rattia panic", "rattia scared", "rattia surprised"]
    gallery_teto = ["teto confused", "teto exasperated", "teto happy", "teto sad"]
#    gallery_unclean = ["unclean scared", "unclean smile"]
    
    #list the images for the rest of expressions for each sprite here:
    
#    gallery_dev_items = ["concept ghost chi", "concept IMG_1797", "concept IMG_1798", "concept IMG_1799", "concept moon", "concept s_khir1", "concept sprite_sketches_copy", "concept s_khir3"]
#    gallery_khir_concept = ["concept s_khir3"]
    gallery_dev_items = ["con1", "con2", "con3", "con4", "con5", "con6", "con7", "con8", "con9"]
    
    #how many rows and columns in the gallery screens?
    gal_rows = 3
    gal_cols = 3
    #thumbnail size in pixels:
    thumbnail_x = 267
    thumbnail_y = 150
    gal_xpos = 50
    gal_ypos = 70
    #Galleries settings - end
    
    gal_cells = gal_rows * gal_cols    
    
    g_cg = Gallery()
    for gal_item in gallery_cg_items:
        g_cg.button(gal_item + " butt")
        g_cg.image(gal_item)
        g_cg.unlock(gal_item)
    g_cg.transition = fade
    cg_page=0

    g_dev = Gallery()
    for gal_item in gallery_dev_items:
        g_dev.button(gal_item + " butt")
        g_dev.image("#000", gal_item)
        # if gal_item=="concept s_khir":
            # for item in gallery_khir_concept:
                # g_dev.image("#000", item)

    g_dev.transition = fade
    dev_page=0
    
    g_bg = Gallery()
    for gal_item in gallery_bg_items:
        g_bg.button(gal_item + " butt")
        g_bg.image(gal_item)
        g_bg.unlock(gal_item)
        
        #BGs with variations:
        # if gal_item == "home day":
            # g_bg.image( "home night")
            # g_bg.unlock("home night")
    g_bg.transition = fade
    bg_page=0
    
    g_ch = Gallery()
    for gal_item in gallery_ch_items:
        g_ch.button(gal_item + " butt")
        
        if gal_item=="chi normal":
            g_ch.image("#000", gal_item)
            g_ch.unlock(gal_item)
            for item in gallery_chi:
                g_ch.image("#000", item)
                g_ch.unlock(item)

        if gal_item=="khir normal":
            g_ch.image("#000", gal_item)
            g_ch.unlock(gal_item)
            for item in gallery_khir:
                g_ch.image("#000", item)
                g_ch.unlock(item)

        if gal_item=="mo normal":
            g_ch.image("#000", gal_item)
            g_ch.unlock(gal_item)
            for item in gallery_mo:
                g_ch.image("#000", item)
                g_ch.unlock(item)

        if gal_item=="rattia normal":
            g_ch.image("#000", gal_item)
            g_ch.unlock(gal_item)
            for item in gallery_rattia:
                g_ch.image("#000", item)
                g_ch.unlock(item)
                
        if gal_item=="teto normal":
            g_ch.image("#000", gal_item)
            g_ch.unlock(gal_item)
            for item in gallery_teto:
                g_ch.image("#000", item)
                g_ch.unlock(item)
                
        if gal_item=="unclean normal":
            g_ch.image("#000", gal_item)
            g_ch.unlock(gal_item)
#            for item in gallery_unclean:
#                g_ch.image("#000", item)
#                g_ch.unlock(item)
                
    g_ch.transition = fade
    ch_page=0

init:
    $ border_size=6
    image gal_bg=LiveComposite((thumbnail_x, thumbnail_y), (0,0), Solid("dadada"))    
    image gal_frame_x=LiveComposite((thumbnail_x, border_size), (0,0), Solid("CECECE"))
    image gal_frame_y=LiveComposite((border_size, thumbnail_y-border_size*2), (0,0), Solid("CECECE"))
    image gal_frame_x_sel=LiveComposite((thumbnail_x, border_size), (0,0), Solid("4abff2"))
    image gal_frame_y_sel=LiveComposite((border_size, thumbnail_y-border_size*2), (0,0), Solid("4abff2"))
    
init +1:
    image gal_locked=LiveComposite((thumbnail_x, thumbnail_y), (0,0), ImageReference("gal_bg"), (42,50), Text("Locked", style="title"))
    
    image gal_frame=LiveComposite((thumbnail_x, thumbnail_y), (border_size*2,1), ImageReference("gal_frame_x"), (border_size*2,thumbnail_y-border_size+1), ImageReference("gal_frame_x"), (border_size*2,border_size+1), ImageReference("gal_frame_y"), (thumbnail_x+border_size,border_size+1), ImageReference("gal_frame_y"))

    image gal_frame_sel=LiveComposite((thumbnail_x, thumbnail_y), (border_size*2,1), ImageReference("gal_frame_x_sel"), (border_size*2,thumbnail_y-border_size+1), ImageReference("gal_frame_x_sel"), (border_size*2,border_size+1), ImageReference("gal_frame_y_sel"), (thumbnail_x+border_size,border_size+1), ImageReference("gal_frame_y_sel"))
    
init +1 python:
    #Here we create the thumbnails. We create a grayscale thumbnail image for BGs, but we use a special "locked" image for CGs to prevent spoilers.
    for gal_item in gallery_cg_items:
        renpy.image (gal_item + " butt", im.Scale(ImageReference(gal_item), thumbnail_x, thumbnail_y))
    for gal_item in gallery_bg_items:
        renpy.image (gal_item + " butt", im.Scale(ImageReference(gal_item), thumbnail_x, thumbnail_y))
    for gal_item in gallery_dev_items:
        renpy.image (gal_item + " butt", im.Scale(ImageReference(gal_item), thumbnail_x, thumbnail_y))
    for gal_item in gallery_ch_items:
        renpy.image (gal_item + " butt", LiveComposite((thumbnail_x, thumbnail_y), (0,0), ImageReference("gal_bg"), (int(thumbnail_x/4),0), ProportionalScale(ImageReference(gal_item), thumbnail_x, thumbnail_y)))
#        renpy.image (gal_item + " butt", LiveComposite((thumbnail_x, thumbnail_y), (0,0), ImageReference("gal_bg"), (int(thumbnail_x/4),0), im.Scale(ImageReference(gal_item), thumbnail_x, thumbnail_y)))
        
screen cg_gallery:
    tag menu
    use extras
    add "cg_gallery_title" xpos 152 ypos 22
    frame background None xpos gal_xpos ypos gal_ypos:
        grid gal_rows gal_cols:
            ypos 10
            $ i = 0
            $ next_cg_page = cg_page + 1            
            if next_cg_page > int(len(gallery_cg_items)/gal_cells):
                $ next_cg_page = 0
            for gal_item in gallery_cg_items:
                $ i += 1
                if i <= (cg_page+1)*gal_cells and i>cg_page*gal_cells:
                    add g_cg.make_button(gal_item + " butt", gal_item + " butt", ImageReference("gal_locked"), ImageReference("gal_frame_sel"), ImageReference("gal_frame"), background=None, bottom_margin=24)
                    
            for j in range(i, (cg_page+1)*gal_cells): #we need this to fully fill the grid
                null
        frame:
            yalign 0.97
            vbox:
                if len(gallery_cg_items)>gal_cells:
                    textbutton _("Next Page") action [SetVariable('cg_page', next_cg_page), ShowMenu("cg_gallery")]
    
screen bg_gallery:
    tag menu
    use extras
    add "bg_gallery_title" xpos 152 ypos 22
    frame background None xpos gal_xpos ypos gal_ypos:
        grid gal_rows gal_cols:
            ypos 10
            $ i = 0
            $ next_bg_page = bg_page + 1
            if next_bg_page > int(len(gallery_bg_items)/gal_cells):
                $ next_bg_page = 0
            for gal_item in gallery_bg_items:
                $ i += 1
                if i <= (bg_page+1)*gal_cells and i>bg_page*gal_cells:                
                    add g_bg.make_button(gal_item + " butt", gal_item + " butt", ImageReference("gal_locked"), ImageReference("gal_frame_sel"), ImageReference("gal_frame"), background=None, bottom_margin=24)
                    #add g_bg.make_button(gal_item + " butt", gal_item + " butt", gal_item + " butt dis", xalign=0.5, yalign=0.5, idle_border=None, background=None, bottom_margin=24)
            for j in range(i, (bg_page+1)*gal_cells):
                null
        frame:
            yalign 0.97
            vbox:
                if len(gallery_bg_items)>gal_cells:
                    textbutton _("Next Page") action [SetVariable('bg_page', next_bg_page), ShowMenu("bg_gallery")]

screen ch_gallery:
    tag menu
    use extras
    add "character_gallery_title" xpos 152 ypos 22
    frame background None xpos gal_xpos ypos gal_ypos:
        grid gal_rows gal_cols:
            ypos 10
            $ i = 0
            $ next_ch_page = ch_page + 1
            if next_ch_page > int(len(gallery_ch_items)/gal_cells):
                $ next_ch_page = 0
            for gal_item in gallery_ch_items:
                $ i += 1
                if i <= (ch_page+1)*gal_cells and i>ch_page*gal_cells:
                    add g_ch.make_button(gal_item + " butt", gal_item + " butt", ImageReference("gal_locked"), ImageReference("gal_frame_sel"), ImageReference("gal_frame"), background=None, bottom_margin=24)
            for j in range(i, (ch_page+1)*gal_cells):
                null
        frame:
            yalign 0.97
            vbox:
                if len(gallery_ch_items)>gal_cells:
                    textbutton _("Next Page") action [SetVariable('ch_page', next_ch_page), ShowMenu("ch_gallery")]

screen dev_gallery:
    tag menu
    use extras
    add "concept_gallery_title" xpos 152 ypos 22
    frame background None xpos gal_xpos ypos gal_ypos:
        grid gal_rows gal_cols:
            ypos 10
            $ i = 0
            $ next_dev_page = dev_page + 1            
            if next_dev_page > int(len(gallery_dev_items)/gal_cells):
                $ next_dev_page = 0
            for gal_item in gallery_dev_items:
                $ i += 1
                if i <= (dev_page+1)*gal_cells and i>dev_page*gal_cells:
                    add g_dev.make_button(gal_item + " butt", gal_item + " butt", ImageReference("gal_locked"), ImageReference("gal_frame_sel"), ImageReference("gal_frame"), background=None, bottom_margin=24)
            for j in range(i, (dev_page+1)*gal_cells): #we need this to fully fill the grid
                null
        frame background None:
            yalign 0.8
            vbox:
                if len(gallery_dev_items)>gal_cells:
                    textbutton _("Next Page") action [SetVariable('dev_page', next_dev_page), ShowMenu("dev_gallery")]

